//CollerDedans_406f.js
// 05.11.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Copier et insrer une image dans un bloc vide ou remplacer une image

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// l'intervalle en secondes (va tre compare au temps depuis 
// le dernier lancement du script: dure plus longue = l'image est copi;
// dure plus courte = l'image est insre)
var timeDelay = 5;

// mmoriser la date actuelle et la comparer  l'ancienne
var copyImg = true;
var curDate = new Date();
var milliSecs = curDate.getTime();
var oldTime = 0;
try {
	oldTime = (app.extractLabel("timeStamp"))*1;
	if ((milliSecs - oldTime) < (timeDelay * 1000)) {
		copyImg = false;
	}
}
catch (e) {
}

// entrer le millisecondes
app.insertLabel("timeStamp", ("" + milliSecs));

// une rfrence au premier document
var curDoc = app.documents[0];

// vrifier s'il y a une slection
if (app.selection.length == 0) {
	alert ("Il faut slectionner un bloc image.", "Attention");
	exit();
}

// tester la slection
var curSel = app.selection[0];
var selType = curSel.constructor.name;
if (selType == "Rectangle" || selType == "Oval" || selType == "Polygon") {
	if (curSel.graphics.length != 0) {
		var curImage = curSel.graphics[0];
	}
	else {
		var curImage = -1;
		copyImg = false;
	}
}
else if (selType == "Image" || selType == "EPS" || selType == "PDF") {
	var curImage = curSel;
}
else {
	alert ("La slection est invalide.", "Stop");
	exit();
}

// copier ou insrer (selon l'intervalle)
if (copyImg) {
	var curFrame = curImage.parent;
	var fRot = curFrame.rotationAngle;
	var iRot = curImage.absoluteRotationAngle;
	var fShe = curFrame.shearAngle;
	var iShe = curImage.absoluteShearAngle;
	if (fRot !=0) {
		curFrame.rotationAngle = 0;
	}
	if (iRot !=0) {
		curImage.absoluteRotationAngle = 0;
	}
	if (fShe !=0) {
		curFrame.shearAngle = 0;
	}
	if (iShe !=0) {
		curImage.absoluteShearAngle = 0;
	}
	var iGB = curImage.geometricBounds;
	var fGB = curFrame.geometricBounds;
	var hSc = curImage.horizontalScale;
	var vSc = curImage.verticalScale;
	var shiftY = iGB[0]-fGB[0];
	var shiftX = iGB[1]-fGB[1];
	var moveBy = ""+iRot+"#"+iShe+"#"+shiftX+"#"+shiftY+"#"+hSc+"#"+vSc;
	app.insertLabel("shiftVal", moveBy);
	curDoc.select(curImage);
	app.copy();
	if (fRot !=0) {
		curFrame.rotationAngle = fRot;
	}
	if (iRot !=0) {
		curImage.absoluteRotationAngle = iRot;
	}
	if (fShe !=0) {
		curFrame.shearAngle = fShe;
	}
	if (iShe !=0) {
		curImage.absoluteShearAngle = iShe;
	}
	curDoc.select(curSel);
	// annoncer que l'image est copie
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "L'image est copie.");
	dlog.show();
	// une petite pause
	$.sleep(500);
	// fermer la fentre
	dlog.close();
}
else {
	var moveBy = app.extractLabel("shiftVal");
	var params = moveBy.split("#");
	var iRot   = params[0]*1;
	var iShe   = params[1]*1;
	var shiftX = params[2];
	var shiftY = params[3];
	var hSc    = params[4]*1;
	var vSc    = params[5]*1;
	var gRot   = curSel.rotationAngle; 
	if (gRot  !=0) {
		curSel.rotationAngle = 0;
	}
	var gShe  = curSel.shearAngle; 
	if (gShe !=0) {
		curSel.shearAngle = 0;
	}
	if (curImage != -1) {
		curFrame    = curImage.parent;
		curImage.remove();
	}
	else {
		curFrame = curSel;
	}
	var fGB    = curFrame.geometricBounds;
	var shiftY = fGB[0]+(shiftY*1);
	var shiftX = fGB[1]+(shiftX*1);
	app.selection = curFrame;
	try {
		app.pasteInto();
		if (curFrame.graphics.length != 0) {
			var curImage = curFrame.graphics[0];
			curImage.move([shiftX, shiftY]);
			curImage.horizontalScale = hSc;
			curImage.verticalScale = vSc;
			curFrame.rotationAngle = gRot;
			curImage.absoluteRotationAngle = iRot;
			curFrame.shearAngle = gShe;
			curImage.absoluteShearAngle = iShe;
		}
	}
	catch (e) {
		alert ("Le contenu du presse-papiers ne peut pas tre coll dans le bloc slectionn.", "Attention");
	}
}